from django.db import models
from apps.account.models import User
from libs import ModelMixin, human_datetime

import json
# Create your models here.

class Ostransfer(models.Model, ModelMixin):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    digest = models.CharField(max_length=32, db_index=True)
    host_id = models.IntegerField(null=True)
    host_ids = models.TextField()
    host_hostnames = models.TextField()
    updated_at = models.CharField(max_length=20, default=human_datetime)

    def to_view(self):
        tmp = self.to_dict()
        tmp['host_ids'] = json.loads(self.host_ids)
        tmp['host_hostnames'] = json.loads(self.host_hostnames)
        return tmp

    class Meta:
        db_table = 'os_transfer'
        ordering = ('-id',)
