from django.shortcuts import render
from django.core import serializers
from apps.abrtMonitor.models import AbrtLogInfo
from django.http import HttpResponse
from django.http import JsonResponse
import json

# Create your views here.
#test
def index(request):
    return HttpResponse("Hello, world. You're at the polls index.")

def selectAllInfo(request):
    #AbrtLogInfo.objects.create(ip='192.168.1.1',time='2024-05-13')
    #AbrtLogInfo.objects.filter(ip='192.168.1.1').delete()
    data = []
    entries = AbrtLogInfo.objects.filter(delFlag=0)
    for entrie in entries:
        d = {}
        d['id'] = entrie.id
        d['ip'] = entrie.ip
        d['dir_name'] = entrie.dir_name
        d['hostname'] = entrie.hostname
        d['os_release'] = entrie.os_release
        d['architecture'] = entrie.architecture
        d['abrt_version'] = entrie.abrt_version
        d['crash_function'] = entrie.crash_function
        d['executable'] = entrie.executable
        d['kernel'] = entrie.kernel
        d['last_occurrence'] = entrie.last_occurrence
        d['pwd'] = entrie.pwd
        d['reason'] = entrie.reason
        d['time'] = entrie.time.strftime('%Y-%m-%d %H:%M:%S')
        data.append(d)
    retdata = {}
    retdata['data'] = data
    return JsonResponse(retdata)
    
def selectInfo(request,ip_addr, name):
    data = {}
    entries = AbrtLogInfo.objects.filter(ip=ip_addr,delFlag=0)
    data[ip_addr] = json.loads(serializers.serialize("json",entries))
    return JsonResponse(data)

def checkExists(request,ip_addr,name):
    entries = AbrtLogInfo.objects.filter(ip=ip_addr,dir_name=name)
    if entries.count() == 0:
        return HttpResponse("0")
    else:
        if entries[0].delFlag == 1:   
            return HttpResponse("2")
        else:
            return HttpResponse("1")


def deleteInfo(request,ip_addr,name):
    AbrtLogInfo.objects.filter(ip=ip_addr,dir_name=name,delFlag=1).delete()
    entries = AbrtLogInfo.objects.filter(ip=ip_addr,dir_name=name)
    if entries.count() == 0:
        return HttpResponse("1")
    else:
        return HttpResponse("0")
    

def updateInfo(request,ip_addr,name):
    AbrtLogInfo.objects.filter(ip=ip_addr,dir_name=name,delFlag=0).update(delFlag=1)
    entries = AbrtLogInfo.objects.filter(ip=ip_addr,dir_name=name, delFlag=1)
    data = {}
    if entries.count() == 0:
        data['data'] = 'failed'
    else:
        data['data'] = 'success'
    return JsonResponse(data)

def insertInfo(request):
    if request.method == 'POST':
        raw_data = request.body.decode('utf-8')
        json_data = json.loads(raw_data)
        if json_data['crash_function'] is None:
            return HttpResponse("0")
        abLog = AbrtLogInfo.objects.create(ip=json_data['ip'],hostname=json_data['hostname'],os_release=json_data['os_release'],architecture=json_data['architecture'],abrt_version=json_data['abrt_version'],crash_function=json_data['crash_function'],executable=json_data['executable'],kernel=json_data['kernel'],last_occurrence=json_data['last_occurrence'],pwd=json_data['pwd'],reason=json_data['reason'],time=json_data['time'],dir_name=json_data['dir_name'],delFlag=0)
        abLog.save()
        entries = AbrtLogInfo.objects.filter(ip=json_data['ip'],dir_name=json_data['dir_name'])
        data = {}
        if entries.count() == 0:
            return HttpResponse("0")
        else:
            return HttpResponse("1")

