from django.test import TestCase,RequestFactory
from django.urls import reverse
from apps.account.views import login,logout
import os
import json


class LoginTestCase(TestCase):
    def setUp(self):
        print("LoginTestCase登录接口测试数据准备:")
        self.login_info = {
            "username":"admin",
            "password":123,
        }
        self.login_info_err = {"username":"admin","password":1234}
        self.factory = RequestFactory()
        self.headers={"User-Agent": "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.120 Safari/537.36"}
        print("登录信息准备完成!")

    def test_login1(self):
        print("test_login1登录接口测试开始:")
        requestIn = self.factory.post('/api/account/login/',data = self.login_info)
        responseIn = login(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("登录成功!")
  
    def test_login2(self):
        print("test_login2登录接口测试开始:")
        print("第一次登录:")
        requestIn = self.factory.post('/api/account/login/',data = self.login_info)
        responseIn = login(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("第一次登录成功!")
        print("第二次登录:")
        responseIn2 = login(requestIn)
        self.assertEqual(responseIn2.status_code, 200)
        print("第二次登录成功!")
    '''
    def test_login3(self):
        print("test_login3登录接口测试开始:")
        self.factory = RequestFactory()
        json_data = json.dumps(self.login_info_err)
        requestIn = self.factory.post('/api/account/login/',data = json_data,content_type='application/json')
        print("使用错误密码登录:")
        responseIn = login(requestIn)
        self.assertEqual(responseIn.status_code, 200)
    '''
        




