from django.test import TestCase,RequestFactory
from apps.alarm.views import ContactView,handle_test
import json


class ContactViewTestCase(TestCase):
    def setUp(self):
        print("ContactViewTestCase告警联系人信息准备:")
        self.contact_info = {
            "id":100,
            "name":"周昌",
            "phone":"18513081111",
            "email":"zhouchang@nfschina.com",
            "wx_token":"zhou-_-chang",
        }
        self.test_info = {
            "mode":4,
            "value":"zhouchang@nfschina.com",
        }
        self.factory = RequestFactory()
        self.headers={"User-Agent": "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.120 Safari/537.36"}
        print("告警联系人信息准备完成!")

    def test_post(self):
        print("新建联系人测试开始:")
        json_data = json.dumps(self.contact_info)
        requestIn = self.factory.post('/api/alarm/contact/',data = json_data,content_type='application/json')
        contact = ContactView()
        responseIn=contact.post(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("新建联系人成功!")

    def test_handle_test(self):
        print("test_handle_test 告警测试开始:")
        json_data = json.dumps(self.test_info)
        requestIn = self.factory.post('/api/alarm/test/',data = json_data,content_type='application/json')
        responseIn=handle_test(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("告警信息发送成功!")
