from django.test import TestCase,RequestFactory
from apps.config.views import EnvironmentView,ServiceView,HistoryView,ConfigView

import json

class ViewTestCase(TestCase):
    def setUp(self):
        print("EnvironmentView环境测试数据准备开始:")

        self.env_info = {
            'id':'100',
            'name':'develop',
            'key':'fgdfghdgd',
            'desc':'test',
        }
        self.config_info = {
            "o_id":10,
            "type":"app",
            "envs":['1','2'],
            "key":"testKey",
            "is_public":True,
            "value":"test123123",
            "desc":"test"
        }
        self.history_info = {
            "o_id":10,
            "env_id":100,
            "type":"app",
        }
        self.factory = RequestFactory()
        print("数据准备完成!")

    
    def test_Env_post(self):
        print("新建环境开始:")
        json_data = json.dumps(self.env_info)
        requestIn = self.factory.post('/config/environment',data = json_data,content_type='application/json')
        e=EnvironmentView()
        responseIn=e.post(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("新建环境成功!")

    def test_Service_post(self):
        print("新建服务开始:")
        json_data = json.dumps(self.env_info)
        requestIn = self.factory.post('/api/config/service/',data = json_data,content_type='application/json')
        s=ServiceView()
        responseIn=s.post(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("新建服务成功!")

    def test_config_post(self):
        print("新建配置开始:")
        json_data = json.dumps(self.config_info)
        requestIn = self.factory.post('/api/config/',data = json_data,content_type='application/json')
        c = ConfigView()
        responseIn=c.post(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("新建配置成功!")

    
    def test_history_post(self):
        print("开始查询历史记录:")
        json_data = json.dumps(self.history_info)
        requestIn = self.factory.post('/api/config/history/',data = json_data,content_type='application/json')
        h = HistoryView()
        responseIn=h.post(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("历史记录查询成功!")