from datetime import timedelta, datetime
from apps.setting.utils import AppSetting
from apps.ebpf.models import EbpfEvent
from libs.utils import human_datetime

DEFAULT_EBPF_EVENTLOG_KEEP_DAYS = '7'

def scheduled_task():
    try: 
        print('start scheduled_task at %s' % human_datetime()) 
        keep_days = AppSetting.get_default('ebpf_eventlog_keep_days', DEFAULT_EBPF_EVENTLOG_KEEP_DAYS)
        target_time = human_datetime(datetime.now() - timedelta(days=int(keep_days)))
        deleted_count = EbpfEvent.objects.filter(updated_at__lt=target_time).delete()[0]
        print(f"Deleted {deleted_count} rows.")
        print('end scheduled_task at %s' % human_datetime()) 
    except Exception as e:
        print(e)
    
