from django.db import models

from libs import ModelMixin
from libs.utils import human_datetime

class EbpfEvent(models.Model, ModelMixin):
    ip = models.GenericIPAddressField()
    user = models.CharField(max_length=255)
    created_at = models.CharField(max_length=20, default=human_datetime, db_index=True)
    updated_at = models.CharField(max_length=20, default=human_datetime, db_index=True)
    event_type = models.CharField(max_length=1000)
    severity_level = models.CharField(max_length=20)
    event_hash = models.CharField(max_length=255, db_index=True)
    event = models.TextField()

    class Meta:
        db_table = 'ebpf_event'