from django.test import TestCase,RequestFactory
from apps.exec.views import TemplateView,TaskView
import json

class ExecViewTestCase(TestCase):
    def setUp(self):
        print("exec test 数据准备开始:")

        self.template_info = {
            'id':'100',
            'name':'zc_test',
            'type':'test',
            'body':'dmesg -T',
            'interpreter':'sh',
            'host_ids':[0],
            'parameters':[],
            'desc':False,
        }

        self.task_info = {
            'host_ids':[0],
            'command':'dmesg -T',
            'interpreter':'sh',
            'template_id':0,
            'params':{},
        }
        self.factory = RequestFactory()
        print("数据准备完成!")

    def test_template_post(self):
        print("template post 测试开始:")
        json_data = json.dumps(self.template_info)
        requestIn = self.factory.post('/api/exec/template/',data = json_data,content_type='application/json')
        t = TemplateView()
        responseIn=t.post(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("template post 测试成功!")


    def test_task_post(self):
        print("task post 测试开始:")
        json_data = json.dumps(self.task_info)
        requestIn = self.factory.post('/api/exec/do/',data = json_data,content_type='application/json')
        t = TaskView()
        responseIn=t.post(requestIn)
        self.assertEqual(responseIn.status_code, 200)
        print("task post 测试成功!")