from django.db import models
from apps.account.models import User

import json

from libs import ModelMixin, human_datetime

class SoftwareTransfer(models.Model, ModelMixin):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    digest = models.CharField(max_length=32, db_index=True)
    host_id = models.IntegerField(null=True)
    src_dir = models.CharField(max_length=255)
    dst_dir = models.CharField(max_length=255)
    host_ids = models.TextField()
    host_hostnames = models.TextField()
    updated_at = models.CharField(max_length=20, default=human_datetime)

    def to_view(self):
        tmp = self.to_dict()
        tmp['host_ids'] = json.loads(self.host_ids)
        tmp['host_hostnames'] = json.loads(self.host_hostnames)
        return tmp

    def __repr__(self) -> str:
        return super().__repr__()
    
    class Meta:
        db_table = 'software_transfer'
        ordering = ('-id',)
