from django.db import models

from libs import ModelMixin
from libs.utils import human_datetime

class Syslog(models.Model, ModelMixin):
    created_at = models.CharField(max_length=20, default=human_datetime, db_index=True)
    updated_at = models.CharField(max_length=20, default=human_datetime, db_index=True)
    msg_time = models.DateTimeField(auto_now_add=True)
    host = models.CharField(max_length=255, null=True, blank=True)
    pri = models.CharField(max_length=255, null=True, blank=True)
    syslogfacility = models.CharField(max_length=255, null=True, blank=True)
    syslogseverity = models.CharField(max_length=255, null=True, blank=True)
    timegenerated = models.CharField(max_length=255, null=True, blank=True)
    timereported = models.CharField(max_length=255, null=True, blank=True)
    hostname = models.CharField(max_length=255, null=True, blank=True)
    programname = models.CharField(max_length=255, null=True, blank=True)
    procid = models.CharField(max_length=255, null=True, blank=True)
    msg = models.TextField(null=True, blank=True)
    app_name = models.CharField(max_length=255, null=True, blank=True)
    msgid = models.CharField(max_length=255, null=True, blank=True)
    protocol_version = models.CharField(max_length=255, null=True, blank=True)
    structured_data = models.CharField(max_length=255, null=True, blank=True)
    fromhost = models.CharField(max_length=255, null=True, blank=True)
    fromhost_ip = models.CharField(max_length=255, null=True, blank=True)
    myhostname = models.CharField(max_length=255, null=True, blank=True)
    now = models.CharField(max_length=255, null=True, blank=True)
    year = models.CharField(max_length=255, null=True, blank=True)
    month = models.CharField(max_length=255, null=True, blank=True)
    day = models.CharField(max_length=255, null=True, blank=True)
    hour = models.CharField(max_length=255, null=True, blank=True)
    minute = models.CharField(max_length=255, null=True, blank=True)

    class Meta:
        db_table = 'syslogs'

# %pri%：消息的优先级（包括facility和severity）。
# %syslogfacility%：消息的设施（例如，kern, user, mail 等）。
# %syslogseverity%：消息的严重性（例如，info, warning, error 等）。
# %timegenerated%：消息生成的时间。
# %timereported%：消息报告的时间。
# %hostname%：生成消息的主机名。
# %programname%：生成消息的程序名。
# %procid%：生成消息的进程ID。
# %msg%：实际的日志消息内容。
# %app-name%：应用程序名称（通常与程序名相同）。
# %msgid%：消息ID。
# %protocol-version%：使用的syslog协议版本。
# %structured-data%：结构化数据元素（用于syslog-protocol版本1）。
# %fromhost%：消息来源的主机名或IP地址。
# %fromhost-ip%：消息来源的IP地址。
# %$myhostname%：本地主机名。
# %$now%：当前时间。
# %$year%, %$month%, %$day%, %$hour%, %$minute%, %$second%：当前日期和时间的各个部分。

#$template JsonTemplate,"{\"pri\": \"%pri%\",\"syslogfacility\": \"%syslogfacility%\",\"syslogseverity\": \"%syslogseverity%\",\"timegenerated\": \"%timegenerated%\",\"timereported\": \"%timereported%\",\"hostname\": \"%hostname%\",\"programname\": \"%programname%\",\"procid\": \"%procid%\",\"msg\": \"%msg%\",\"app-name\": \" %app-name%\",\"msgid\": \"%msgid%\",\"protocol-version\": \"%protocol-version%\",\"structured-data\": \"%structured-data%\",\"fromhost\": \"%fromhost%\",\"fromhost-ip\": \"%fromhost-ip%\",\"myhostname\": \"%$myhostname%\",\"now\": \"%$now%\",\"year\": \"%$year%\",\"month\": \"%$month%\",\"day\": \"%$day%\",\"hour\": \"%$hour%\",\"minute\": \"%$minute%\"}"