#!/usr/bin/bash
cd "$(dirname "$0")"
host=$1
port=$2

if [ -z "$host" ] || [ -z "$port" ]; then
    echo "Usage:  <nfsops_web_host> <nfsops_web_port>"
    exit 1
fi

websockify/run -v \
    --token-plugin BaseTokenAPI \
    --token-source "http://${host}:${port}/api/host/vnc/get_vnc_host_port/%s/" \
    --auth-plugin NfsOpsAuth \
    --auth-source http://${host}:${port}/api/host/vnc/auth/%s/%s/ \
    8787

# Eg:
# bash start_websockify.sh 60.10.11.40 3000