#!/usr/bin/python3

import os
import sys
import time
import requests
import json
import shutil

ip = '__REPLACE_IP__'
nfs_ops_base_url= '__REPLACE_NFS_OPS_BASE_URL__'

abrt_log_dir = '/var/spool/abrt'
file_name_list = ['hostname','os_release','architecture','abrt_version','crash_function','executable','kernel','last_occurrence','pwd','reason','time', 'dir_name']
insert_url = f"{nfs_ops_base_url}/api/abrtMonitor/abrtinsertinfo/"
check_url = f"{nfs_ops_base_url}/api/abrtMonitor/abrtcheckinfo"
delete_url = f"{nfs_ops_base_url}/api/abrtMonitor/abrtdeleteinfo"

def get_file_data(path):
    if os.path.exists(path):
        with open(path,'r',encoding='UTF-8') as f:
            res = f.read()
            return res.strip('\n')

def post_insert_data(ip,dir_name,path):
    hostname = get_file_data(path+'/'+ file_name_list[0]) 
    os_release = get_file_data(path+'/'+ file_name_list[1]) 
    architecture = get_file_data(path+'/'+ file_name_list[2])
    abrt_version = get_file_data(path+'/'+ file_name_list[3])
    crash_function = get_file_data(path+'/'+ file_name_list[4])
    executable = get_file_data(path+'/'+ file_name_list[5])
    kernel = get_file_data(path+'/'+ file_name_list[6])
    last_occurrence = get_file_data(path+'/'+ file_name_list[7])
    pwd = get_file_data(path+'/'+ file_name_list[8])
    reason = get_file_data(path+'/'+ file_name_list[9])
    time_str = get_file_data(path+'/'+ file_name_list[10])
    time_tuple = time.gmtime(int(time_str))
    time1 = time.strftime("%Y-%m-%d %H:%M:%S", time_tuple)
    data = {}
    data["ip"] = ip
    data["hostname"] = hostname
    data["os_release"] = os_release
    data["architecture"] = architecture
    data["abrt_version"] = abrt_version
    data["crash_function"] = crash_function
    data["executable"] = executable
    data["kernel"] = kernel
    data["last_occurrence"] = last_occurrence
    data["pwd"] = pwd
    data["reason"] = reason
    data["time"] = time1
    data["dir_name"] = dir_name
    res = requests.post(url=insert_url,data=json.dumps(data))
    if res.text == "1":
        print("数据插入成功")
    else:
        pass

def delete_data(ip,file,path):
    run_delete_url = f"{delete_url}/{ip}/{file}/"
    #print(run_delete_url)
    res = requests.get(url=run_delete_url)
    if res.text == "1":
        print("数据删除成功")
    else:
        print("数据删除失败")
    print("开始删除abrt log文件")
    print(path)
    shutil.rmtree(path, ignore_errors=True)
    print("abrt log文件删除成功")

def deal_data(ip,file,path):
    run_check_url = f"{check_url}/{ip}/{file}/"
    #print(run_check_url)
    try:
        res = requests.get(url=run_check_url)
        if res.text == "0":
            post_insert_data(ip,file,path)
        elif res.text == "2":
            delete_data(ip,file,path)
        else:
            pass
    except:
        pass

if __name__ == '__main__':
    while True: 
        for file in os.listdir(abrt_log_dir):
            if file.startswith("ccpp"):
                path = os.path.join(abrt_log_dir,file)
                if os.path.isdir(path):
                    deal_data(ip,file,path)
        time.sleep(5)


