#!/usr/bin/bash

HOSTNAME=`echo $1 | awk -F'//' '{print $2}'`
#初始化vnc服务器
init_vnc_server(){
	yum install tigervnc-server expect -y

	cp /lib/systemd/system/vncserver@.service /etc/systemd/system/vncserver@:1.service

	echo ":1=root" >> /etc/tigervnc/vncserver.users

	sed -i '/\[Service\]/a\WorkingDirectory=/root\nUser=root\nGroup=root' /etc/systemd/system/vncserver@:1.service
	chmod +x setvncpasswd
	./setvncpasswd
	systemctl daemon-reload
	systemctl enable vncserver@:1.service
	systemctl start vncserver@:1.service
	systemctl stop firewalld
	systemctl disable firewalld
}


init_syslog(){
	echo "*.* @$HOSTNAME:514;JsonTemplate" >> /etc/rsyslog.d/00-nfs-ops.conf
	systemctl restart rsyslog.service
}


init_vnc_server
init_syslog
