function stringToBase64URLSafe(str) {
    const uint8Array = new TextEncoder().encode(str);
    const base64 = btoa(String.fromCharCode(...uint8Array));
    return base64.replace(/\+/g, '-').replace(/\//g, '_').replace(/=+$/, '');
}

function base64URLSafeToString(base64Str) {
    let normalBase64 = base64Str.replace(/-/g, '+').replace(/_/g, '/');
    switch (normalBase64.length % 4) {
        case 0:
            break;
        case 2:
            normalBase64 += '==';
            break;
        case 3:
            normalBase64 += '=';
            break;
        default:
            throw 'Illegal base64url string!';
    }
    const decodedArray = atob(normalBase64);
    const uint8Array = new Uint8Array(decodedArray.length);
    for (let i = 0; i < decodedArray.length; i++) {
        uint8Array[i] = decodedArray.charCodeAt(i);
    }
    return new TextDecoder().decode(uint8Array);
}

function decodeHostIdAndPwd(base64Str) {
    const decodedStr = base64URLSafeToString(base64Str);
    return decodedStr.split('$$$');
}

function encodeHostIdAndPwd(hostId, pwd) {
    const concatenatedStr = `${hostId}$$$${pwd}`;
    return stringToBase64URLSafe(concatenatedStr);
}

window.decodeHostIdAndPwd = decodeHostIdAndPwd;
window.encodeHostIdAndPwd = encodeHostIdAndPwd;