#!/usr/bin/bash

## 登录 grafana 获取 cookie
curl --location --request POST 'http://localhost/grafana/login' --header 'Content-Type: application/json' \
--data '{"user": "admin", "password": "admin"}' -c cookie
if [ $? -ne 0 ]
then
    echo "grafana login error"
    exit 1
fi

echo ""

## 初始化 datasource
curl -c cookie -b cookie --location --request POST 'http://localhost/grafana/api/datasources' \
--header 'Content-Type: application/json' \
--data '{"name": "prometheus", "type": "prometheus", "url": "http://127.0.0.1:9090","access": "proxy", "isDefault": true}'
if [ $? -ne 0 ]
then
    echo "grafana configure prometheus datasource error"
    exit 1
fi

echo ""

## 初始化 dashborad
curl -c cookie -b cookie --location --request POST 'http://localhost/grafana/api/dashboards/db' \
--header 'Content-Type: application/json' \
-d @"dashboard.json"
if [ $? -ne 0 ]
then
    echo "grafana configure sysom-appobserver-ntopo-dashboard error"
    exit 1
fi

echo ""

rm -f cookie
